EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_color_set, EFL_FUNC_CALL(r, g, b, a), int r, int g, int b, int a);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_gfx_color_get, EFL_FUNC_CALL(r, g, b, a), int *r, int *g, int *b, int *a);

void _efl_gfx_color_color_code_set(Eo *obj, void *pd, const char *colorcode);


static Eina_Error
__eolian_efl_gfx_color_color_code_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   const char *cval;
   if (!eina_value_string_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_gfx_color_code_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_gfx_color_code_set, EFL_FUNC_CALL(colorcode), const char *colorcode);

const char *_efl_gfx_color_color_code_get(const Eo *obj, void *pd);


static Eina_Value
__eolian_efl_gfx_color_color_code_get_reflect(const Eo *obj)
{
   const char *val = efl_gfx_color_code_get(obj);
   return eina_value_string_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_gfx_color_code_get, const char *, NULL);

static Eina_Bool
_efl_gfx_color_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_GFX_COLOR_EXTRA_OPS
#define EFL_GFX_COLOR_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_gfx_color_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_color_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_gfx_color_code_set, _efl_gfx_color_color_code_set),
      EFL_OBJECT_OP_FUNC(efl_gfx_color_code_get, _efl_gfx_color_color_code_get),
      EFL_GFX_COLOR_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"color_code", __eolian_efl_gfx_color_color_code_set_reflect, __eolian_efl_gfx_color_color_code_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_gfx_color_class_desc = {
   EO_VERSION,
   "Efl.Gfx.Color",
   EFL_CLASS_TYPE_MIXIN,
   0,
   _efl_gfx_color_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_gfx_color_mixin_get, &_efl_gfx_color_class_desc, NULL, NULL);
